class Cell 
    {
        public:
            
            int coord;                      // Coordinate in the 1-dim line
            int status;                     // Status = 0,1   
            int number_of_neighbors;        // Number of neighbors
            int mynumconf;                  // Number of possible configurations
            int *myneigh;                   // Pt to neighbor-labels vector 
            int *mylocalconf;               // Pt to local configuration
            
            int rule_number;                // Number of rules used
            int *rule;                      // Pt to rule vctor
            
            int set_rule(int, int);         // Function: set rule vector
            int update_status(void);        // Function: update status
            
            int set_myneighborhood_vars(int);  // Set dimension of vectors
            
    };
    
int Cell::update_status(void)
{
        // Compute decimal-equivalent of local configuration
        int h,k,mysum;
        mysum=0;
        for (h=0;h<number_of_neighbors+1;h++)
        {
               k=number_of_neighbors-h;
               mysum=mysum+(mylocalconf[k]*int(pow(2,h)));  
        }
                
        status = rule[mynumconf-mysum-1];

        return 0;
}
    
int Cell::set_rule(int decimal, int digits)
{

    	int bits, bit_fac, ini_zeros;

    	bits = int(log(decimal)/log(2));
    	ini_zeros = digits-(bits + 1);
    	
        for(int h = 0; h < ini_zeros; h++)
            {    	
    	       rule[h]=0;
            }
            
    	for(int i = 0; i < bits+1; ++i)
        	{
        		bit_fac=int(pow(2,bits-i));
        		rule[ini_zeros+i]=(decimal / bit_fac > 0? 1 : 0);
        		decimal=(decimal / bit_fac > 0? decimal - bit_fac : decimal);
        	}
        return 0;
}

int Cell::set_myneighborhood_vars(int size)
{
        myneigh = new int[size];
        mylocalconf = new int[size];
        number_of_neighbors = size-1;
        mynumconf = int(pow(2,size));
        rule = new int[mynumconf];
        return 0;
}
